local formspec =
  "size[8,5.5]"..
  "list[current_name;source;0,0;2,1;]" ..
  "list[current_name;product;6,0;2,1;]" ..
  "list[current_player;main;0,1.5;8,3;8]" ..
  "list[current_player;main;0,4.7;8,1;]"..
  "bgcolor[#FC05E344;false]" ..
  "listcolors[#fc059db0;#fc059dd0]"

local function ongetitem(pos)
  local meta = minetest.get_meta(pos)
  if meta:get_int("energy") == 0 then return end
    local timer = minetest.get_node_timer(pos)
    timer:start(1.0)		
end

local function storeprogress(progress) --store the progress of burning in the node meta, burning items aren't take from source, they simply cant be removed any longer when starting to burn
  for x=1,table_getn(progress),1
  do
  meta.get_string("cookprogess_" + i.progress[x])
  end
end

local function restoreprogress(meta,count)
  local progress = {}
  for x=1,count,1
  do
  progress[x] = meta:get_string("cookprogess_" .. x)
  end
  return progress
end

local function mytime(pos, elapsed)
  local meta = minetest.get_meta(pos)
  local energy = meta:get_int("energy")
  local inventory = meta:get_inventory()
  local source = inventory:get_list("source")
  local progress = restoreprogress(meta,table.getn(source))
  local product = inventory:get_list("product")
  
  local newcycle = false -- this is false, if we feel that we need a new cycle we set this to true so that the furnace may cook again (e.g enough fuel and items are available)
  
  --TODO: start cook logic (if there is any energy available start to cook (progress[inventoryslot]++ and commit to meta after all were processed
  
  if (newcycle) then
    minetest.get_node_timer(pos):start(1.0)
  end
  return
end


local function maytake(pos, listname, index, stack, player)
  local meta = minetest.get_meta(pos)
  if listname == "product" then 
    return tonumber(stack:get_count()) --sure, take the stuff that the furnace has cooked for you :D
  end
  local table = restoreprogress(meta,2)
  if table[pos] == nil then return stack:get_count() end
  if listname == "source" then
    if table[pos] > 0 then
      return tonumber(stack:get_count() -1)
  end
  return tonumber(stack:get_count())
  end
end


minetest.register_node(minetest.get_current_modname() .. ":lv_furnace", {
  description = "Electric furnace",
  tiles = {
    "furnace2.png",
    "furnace2.png",
    "furnace2.png",
    "furnace2.png",
    "furnace2.png",
    "furnace.png"
  },
  paramtype2 = "facedir",
  groups = { sparktech_techy = 1,
    sparktech_energy_type = 4,
    sparktech_net_trigger = 1,
    sparktech_energy_max = 300,
    spark_energy_timer = 2},

  on_timer = mytime, -- add a mytimer function 
  allow_metadata_inventory_take = maytake,

  on_construct = function(pos, placer)
    local meta = minetest.get_meta(pos)
    meta:set_string("formspec",formspec)
  local inventory = meta:get_inventory()
  inventory:set_size('source',2)
  inventory:set_size('product',2)
  end,
  on_metadata_inventory_move = ongetitem, --TODO: test these
  on_metadata_inventory_put = ongetitem
})
